=== debian/changelog ===
capstone (5.0.5-1) unstable; urgency=medium

  * New upstream version 5.0.5

 -- Hilko Bengen <bengen@debian.org>  Fri, 17 Jan 2025 18:06:44 +0100
