## capstone 5.0.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -23,7 +23,7 @@
 
 # Check if VERSION is provided externally, otherwise default to 5.0.3
 if(NOT DEFINED PROJECT_VERSION)
-    set(PROJECT_VERSION "5.0.5")
+    set(PROJECT_VERSION "5.0.6")
 endif()
 
 # Use PROJECT_VERSION directly for CPack
