=== debian/changelog ===
capstone (5.0.6-1) unstable; urgency=medium

  * New upstream version 5.0.6
  * control: Update description, fix list formatting
  * Fix "unknown" spelling in codebase (Closes: #1095795)
  * Limit debian/watch to 5.x versions

 -- Hilko Bengen <bengen@debian.org>  Mon, 24 Mar 2025 15:33:46 +0100
