=== debian/control ===
--- 
+++ 
@@ -35,19 +35,26 @@
  framework.
  .
  Features:
-  - Support hardware architectures: ARM, ARM64 (aka ARMv8), Mips, PowerPC &
- Intel.
+  - Support multiple hardware architectures: ARM, ARM64 (ARMv8), BPF,
+    Ethereum VM, M68K, M680X, Mips, MOS65XX, PPC, RISC-V(rv32G/rv64G),
+    SH, Sparc, SystemZ, TMS320C64X, TriCore, Webassembly, XCore and
+    X86 (16, 32, 64)
   - Clean/simple/lightweight/intuitive architecture-neutral API.
-  - Provide details on disassembled instructions (called "decomposer" by some
- others).
-  - Provide some semantics of the disassembled instruction, such as list of
- implicit registers read & written.
-  - Implemented in pure C language, with bindings for Java, OCaml and Python
- ready to use and Ruby, C#, GO & Vala available on git repos.
-  - Native support for Windows & *nix (with OS X, Linux, *BSD & Solaris
- confirmed).
+  - Provide details on disassembled instructions (called "decomposer"
+    by some others).
+  - Provide semantics of the disassembled instruction, such as list of
+    implicit registers read & written.
+  - Implemented in pure C language, with lightweight bindings for
+    Swift, D, Clojure, F#, Common Lisp, Visual Basic, PHP, PowerShell,
+    Emacs, Haskell, Perl, Python, Ruby, C#, NodeJS, Java, GO, C++,
+    OCaml, Lua, Rust, Delphi, Free Pascal & Vala ready either in main
+    code, or provided externally by the community).
+  - Native support for all popular platforms: Windows, Mac OSX, iOS,
+    Android, Linux, \*BSD, Solaris, etc.
   - Thread-safe by design.
   - Special support for embedding into firmware or OS kernel.
+  - High performance & suitable for malware analysis (capable of
+    handling various X86 malware tricks).
   - Distributed under the open source BSD license.
 
 Package: capstone-tool
