=== debian/watch ===
version=4
opts="uversionmangle=s/-rc/~rc/" \
    https://github.com/capstone-engine/capstone/tags \
    .*/archive/refs/tags/v?(5.*)\.tar\.gz
