## capstone 5.0.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,9 +21,9 @@
 # Enable support for MSVC_RUNTIME_LIBRARY
 cmake_policy(SET CMP0091 NEW)
 
-# Check if VERSION is provided externally, otherwise default to 5.0.3
-if(NOT DEFINED PROJECT_VERSION)
-    set(PROJECT_VERSION "5.0.6")
+# Check if VERSION is provided externally, otherwise default to 5.0.7
+if(NOT DEFINED PROJECT_VERSION OR PROJECT_VERSION STREQUAL "")
+    set(PROJECT_VERSION "5.0.7")
 endif()
 
 # Use PROJECT_VERSION directly for CPack
@@ -344,4 +344,3 @@
         arch/X86/X86GenDisassemblerTables.inc
         arch/X86/X86GenDisassemblerTables_reduce.inc
         arch/X86/X86GenInstrInfo.inc
-        arch/X86/X86GenInstrInfo_reduce.inc
