=== debian/changelog ===
capstone (5.0.7-2) unstable; urgency=medium

  * Enforce verbose build (make V=1)
  * Re-add -DFORTIFY_SOURCE=2 ... again

 -- Hilko Bengen <bengen@debian.org>  Sun, 15 Feb 2026 16:59:44 +0100

capstone (5.0.7-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 5.0.7
  * Bump Standards-Version

 -- Hilko Bengen <bengen@debian.org>  Sun, 15 Feb 2026 12:10:56 +0100
