=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
                python3-all-dev,
                python3-setuptools,
                cython3,
-Standards-Version: 4.6.1
+Standards-Version: 4.7.3
 Rules-Requires-Root: no
 Section: devel
 Homepage: https://www.capstone-engine.org/
