=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/architecture.mk

export DEB_BUILD_MAINT_OPTIONS=hardening=+all,+bindnow

%:
	dh $@ --with python3

override_dh_auto_clean \
override_dh_auto_configure \
override_dh_auto_build \
override_dh_auto_test \
override_dh_auto_install:
	$(patsubst override_%,%,$@) -- \
		LIBDIRARCH=lib/$(DEB_HOST_MULTIARCH) V=1
	$(patsubst override_%,%,$@) --sourcedirectory=bindings/python --buildsystem=pybuild

override_dh_auto_test: export LD_LIBRARY_PATH := $(LD_LIBRARY_PATH):$(CURDIR)/tests

override_dh_install:
	dh_install -Xdist-packages/capstone/lib
